diff --git a/include/exiv2/xmp.hpp b/include/exiv2/xmp_exiv2.hpp
similarity index 98%
rename from include/exiv2/xmp.hpp
rename to include/exiv2/xmp_exiv2.hpp
index 05dbbc10..3dc6cfa7 100644
--- a/include/exiv2/xmp.hpp
+++ b/include/exiv2/xmp_exiv2.hpp
@@ -1,6 +1,6 @@
 // ***************************************************************** -*- C++ -*-
 /*
- * Copyright (C) 2004-2017 Andreas Huggel <ahuggel@gmx.net>
+ * Copyright (C) 2004-2015 Andreas Huggel <ahuggel@gmx.net>
  *
  * This program is part of the Exiv2 distribution.
  *
@@ -19,15 +19,15 @@
  * Foundation, Inc., 51 Franklin Street, 5th Floor, Boston, MA 02110-1301 USA.
  */
 /*!
-  @file    xmp.hpp
+  @file    xmp_exiv2.hpp
   @brief   Encoding and decoding of XMP data
   @version $Rev: 3090 $
   @author  Andreas Huggel (ahu)
            <a href="mailto:ahuggel@gmx.net">ahuggel@gmx.net</a>
   @date    13-Jul-07, ahu: created
  */
-#ifndef XMP_HPP_
-#define XMP_HPP_
+#ifndef XMP_EXIV2_HPP_
+#define XMP_EXIV2_HPP_
 
 // *****************************************************************************
 // included header files
@@ -438,4 +438,4 @@ namespace Exiv2 {
 
 }                                       // namespace Exiv2
 
-#endif                                  // #ifndef XMP_HPP_
+#endif                                  // #ifndef XMP_EXIV2_HPP_
diff --git a/samples/CMakeLists.txt b/samples/CMakeLists.txt
index edc7feee..86611f5b 100644
--- a/samples/CMakeLists.txt
+++ b/samples/CMakeLists.txt
@@ -49,7 +49,7 @@ FOREACH(entry ${SAMPLES})
     STRING( REPLACE ".cpp" "" target ${entry})
     ADD_EXECUTABLE( ${target} ${target}.cpp )
     ADD_TEST( ${target}_test ${target} )
-    TARGET_LINK_LIBRARIES( ${target} ${PRIVATE_VAR} exiv2lib ${CMAKE_THREAD_LIBS_INIT} ${EXPAT_LIBRARIES})
+    TARGET_LINK_LIBRARIES( ${target} ${PRIVATE_VAR} exiv2lib ${CMAKE_THREAD_LIBS_INIT} ${EXPAT_LIBRARIES} ${XMPLIBS} )
     INSTALL( TARGETS ${target} ${INSTALL_TARGET_STANDARD_ARGS} )
 ENDFOREACH(entry ${SAMPLES})
 
@@ -62,25 +62,25 @@ ENDIF( MSVC )
 
 SET( MC_SRC ${MC_SRC} metacopy.cpp ../src/utils.cpp )
 ADD_EXECUTABLE( metacopy ${MC_SRC} )
-TARGET_LINK_LIBRARIES( metacopy ${PRIVATE_VAR} exiv2lib ${CMAKE_THREAD_LIBS_INIT} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES})
+TARGET_LINK_LIBRARIES( metacopy ${PRIVATE_VAR} exiv2lib ${CMAKE_THREAD_LIBS_INIT} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES} ${XMPLIBS} )
 INSTALL( TARGETS metacopy ${INSTALL_TARGET_STANDARD_ARGS} )
 
 SET   ( PATHTEST_SRC             ${PATHTEST_SRC}  path-test.cpp ../src/utils.cpp )
 ADD_EXECUTABLE       ( pathtest  ${PATHTEST_SRC} )
 SET_TARGET_PROPERTIES( pathtest  PROPERTIES OUTPUT_NAME path-test )
-TARGET_LINK_LIBRARIES( pathtest  ${PRIVATE_VAR} exiv2lib ${CMAKE_THREAD_LIBS_INIT} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES})
+TARGET_LINK_LIBRARIES( pathtest  ${PRIVATE_VAR} exiv2lib ${CMAKE_THREAD_LIBS_INIT} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES} ${XMPLIBS} )
 INSTALL      ( TARGETS pathtest  ${INSTALL_TARGET_STANDARD_ARGS} )
 
 SET( EXIV2JSON_SRC     exiv2json.cpp Jzon.cpp )
 ADD_EXECUTABLE(        exiv2json ${EXIV2JSON_SRC} )
 SET_TARGET_PROPERTIES( exiv2json PROPERTIES OUTPUT_NAME exiv2json )
-TARGET_LINK_LIBRARIES( exiv2json ${PRIVATE_VAR} ${PRIVATE_VAR} exiv2lib ${CMAKE_THREAD_LIBS_INIT} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES})
+TARGET_LINK_LIBRARIES( exiv2json ${PRIVATE_VAR} ${PRIVATE_VAR} exiv2lib ${CMAKE_THREAD_LIBS_INIT} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES} ${XMPLIBS} )
 INSTALL( TARGETS       exiv2json ${INSTALL_TARGET_STANDARD_ARGS} )
 
 SET( GEOTAG_SRC        geotag.cpp )
 ADD_EXECUTABLE(        geotag    ${GEOTAG_SRC} )
 SET_TARGET_PROPERTIES( geotag    PROPERTIES OUTPUT_NAME geotag )
-TARGET_LINK_LIBRARIES( geotag    ${PRIVATE_VAR} exiv2lib ${CMAKE_THREAD_LIBS_INIT} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES})
+TARGET_LINK_LIBRARIES( geotag    ${PRIVATE_VAR} exiv2lib ${CMAKE_THREAD_LIBS_INIT} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES} ${XMPLIBS} )
 INSTALL( TARGETS       geotag    ${INSTALL_TARGET_STANDARD_ARGS} )
 
 # ******************************************************************************
@@ -90,4 +90,3 @@ INSTALL( FILES exiv2samples.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 )
 # That's all Folks!
 ##
 
-
diff --git a/samples/Makefile b/samples/Makefile
index 1ad6364d..c8993fec 100644
--- a/samples/Makefile
+++ b/samples/Makefile
@@ -118,7 +118,7 @@ DEP = $(BINSRC:%.cpp=$(DEPDIR)/%.d) $(OTHERSRC:%.cpp=$(DEPDIR)/%.d) $(DEPDIR)/Jz
 endif
 
 PREFIX = /usr/local/lib
-LINK.cc += -rpath $(PREFIX) -L$(PREFIX)
+LINK.cc += -rdynamic -rpath $(PREFIX) -L$(PREFIX)
 
 # TODO: This should really not be here. We should use the installed headers
 # to build the samples. Some errors only show up in this scenario, e.g., errors
diff --git a/samples/metacopy.cpp b/samples/metacopy.cpp
index 4acda313..c1f2c99a 100644
--- a/samples/metacopy.cpp
+++ b/samples/metacopy.cpp
@@ -58,7 +58,11 @@ try {
     Exiv2::BasicIo::AutoPtr memIo(new Exiv2::MemIo);
     memIo->transfer(*fileIo);
 
+#ifdef EXV_USING_CPP_ELEVEN
+    Exiv2::Image::AutoPtr readImg = Exiv2::ImageFactory::open(std::move(memIo));
+#else
     Exiv2::Image::AutoPtr readImg = Exiv2::ImageFactory::open(memIo);
+#endif
     assert(readImg.get() != 0);
     readImg->readMetadata();
 
diff --git a/src/CMakeLists.txt b/src/CMakeLists.txt
index 7ae4f56d..0f9a8565 100644
--- a/src/CMakeLists.txt
+++ b/src/CMakeLists.txt
@@ -34,6 +34,7 @@ SET( LIBEXIV2_PRIVATE_HDR canonmn_int.hpp
                           tifffwd_int.hpp
                           tiffimage_int.hpp
                           tiffvisitor_int.hpp
+                          MD5.h
    )
 
 # Add standalone C++ header files to this list
@@ -79,7 +80,7 @@ SET( LIBEXIV2_HDR         ${CMAKE_CURRENT_LIST_DIR}/../include/exiv2/asfvideo.hp
                           ${CMAKE_CURRENT_LIST_DIR}/../include/exiv2/value.hpp
                           ${CMAKE_CURRENT_LIST_DIR}/../include/exiv2/version.hpp
                           ${CMAKE_CURRENT_LIST_DIR}/../include/exiv2/webpimage.hpp
-                          ${CMAKE_CURRENT_LIST_DIR}/../include/exiv2/xmp.hpp
+                          ${CMAKE_CURRENT_LIST_DIR}/../include/exiv2/xmp_exiv2.hpp
                           ${CMAKE_CURRENT_LIST_DIR}/../include/exiv2/xmpsidecar.hpp
                           ${CMAKE_CURRENT_LIST_DIR}/../include/exiv2/utilsvideo.hpp
    )
@@ -139,9 +140,10 @@ SET( LIBEXIV2_SRC         asfvideo.cpp
                           value.cpp
                           version.cpp
                           webpimage.cpp
-                          xmp.cpp
+                          xmp_exiv2.cpp
                           xmpsidecar.cpp
                           utilsvideo.cpp
+                          MD5.cpp
    )
 
 IF( EXIV2_ENABLE_WEBREADY )
@@ -186,14 +188,8 @@ ENDIF( EXIV2_ENABLE_PNG )
 
 INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
 
-##
-# add xmp source if xmp is requested and xmp library not built
-IF( EXIV2_ENABLE_XMP )
-    IF( NOT EXIV2_ENABLE_LIBXMP )
-        SET( LIBEXIV2_SRC ${XMPSRC} ${LIBEXIV2_SRC} )
-    ENDIF( NOT EXIV2_ENABLE_LIBXMP )
-ENDIF( EXIV2_ENABLE_XMP )
 
+IF ( EXV_HAS_XMP_SDK_LIBS )
 ##
 # Create source file lists for applications
 # exiv2 application
@@ -213,17 +209,22 @@ SET( CONNTEST             ../samples/conntest.cpp)
 SET( EXIFPRINT            ../samples/exifprint.cpp)
 # cmdfiletest application
 SET( REMOTETEST           ../samples/remotetest.cpp)
+ENDIF()
 
 ##
 # modify source lists to suit environment
 IF(NOT HAVE_TIMEGM )
     SET( LIBEXIV2_SRC     ${LIBEXIV2_SRC} localtime.c    )
+    IF ( EXV_HAS_XMP_SDK_LIBS )
     SET( EXIV2_SRC        ${EXIV2_SRC}    localtime.c    )
+    ENDIF()
     SET( PATHTEST_SRC     ${PATHTEST_SRC} localtime.c    )
 ENDIF( NOT HAVE_TIMEGM )
 
 IF( MSVC )
+    IF ( EXV_HAS_XMP_SDK_LIBS )
     SET( EXIV2_SRC        ${EXIV2_SRC}    getopt_win32.c )
+    ENDIF()
     SET( LIBEXIV2_SRC     ${LIBEXIV2_SRC} getopt_win32.c )
 ENDIF( MSVC )
 
@@ -258,34 +259,29 @@ ENDIF()
 if ( MSVC )
     source_group("Header Files" FILES ${LIBEXIV2_HDR} )
     TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${ZLIB_LIBRARIES} )
-    TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${EXPAT_LIBRARIES} )
     source_group("Header Files" FILES ${LIBCURL_HDR} )
     TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${CURL_LIBRARIES} )
     source_group("Header Files" FILES ${SSH_HDR} )
     TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${SSH_LIBRARIES} )
 else()
     if ( UNIX AND NOT FREEBSD )
-        TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} dl ${EXPAT_LIBRARIES} )
         TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} dl ${CURL_LIBRARIES} )
         TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} dl ${SSH_LIBRARIES} )
         TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} dl ${CMAKE_THREAD_LIBS_INIT} )
     else()
-        TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${EXPAT_LIBRARIES} )
         TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${CURL_LIBRARIES} )
         TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${SSH_LIBRARIES} )
         TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${CMAKE_THREAD_LIBS_INIT} )
     endif()
 endif()
 
-if( EXIV2_ENABLE_LIBXMP )
-    ADD_DEPENDENCIES( exiv2lib xmp )
+if( EXIV2_ENABLE_XMP )
     if  ( MSVC )
         LINK_DIRECTORIES(${LIBRARY_OUTPUT_PATH}/$(ConfigurationName))
     else()
-        ADD_DEPENDENCIES( exiv2lib xmp)
-        TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${EXPAT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
+        TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${CMAKE_THREAD_LIBS_INIT})
     endif(MSVC)
-    TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} xmp )
+    TARGET_LINK_LIBRARIES( exiv2lib ${PRIVATE_VAR} ${XMPLIBS} )
 ENDIF()
 
 IF( EXIV2_ENABLE_PNG )
@@ -315,16 +311,21 @@ INSTALL( TARGETS exiv2lib ${INSTALL_TARGET_STANDARD_ARGS} )
 include(../CMake_msvc.txt)
 msvc_runtime_configure(${EXIV2_ENABLE_SHARED} ${EXIV2_ENABLE_DYNAMIC_RUNTIME})
 
-# ******************************************************************************
-# exiv2 application
+ # ******************************************************************************
+ # exiv2 application
+
+IF ( EXV_HAS_XMP_SDK_LIBS )
 ADD_EXECUTABLE( exiv2 ${EXIV2_SRC}  ${EXIV2_HDR} )
-TARGET_LINK_LIBRARIES( exiv2 exiv2lib ${LIBINTL_LIBRARIES} )
+TARGET_LINK_LIBRARIES( exiv2 exiv2lib )
 INSTALL( TARGETS exiv2 ${INSTALL_TARGET_STANDARD_ARGS} )
+ENDIF()
 
 # ******************************************************************************
 # connection test application
+IF ( EXV_HAS_XMP_SDK_LIBS )
 ADD_EXECUTABLE( conntest ${CONNTEST} )
-TARGET_LINK_LIBRARIES( conntest ${PRIVATE_VAR}  exiv2lib ${CURL_LIBRARIES} ${SSH_LIBRARIES} ${LIBINTL_LIBRARIES} )
+TARGET_LINK_LIBRARIES( conntest ${PRIVATE_VAR}  exiv2lib ${CURL_LIBRARIES} ${SSH_LIBRARIES})
+ENDIF()
 
 # ******************************************************************************
 # exifprint application
@@ -333,8 +334,10 @@ TARGET_LINK_LIBRARIES( conntest ${PRIVATE_VAR}  exiv2lib ${CURL_LIBRARIES} ${SSH
 
 # ******************************************************************************
 # remotetest application
+IF ( EXV_HAS_XMP_SDK_LIBS )
 ADD_EXECUTABLE( remotetest ${REMOTETEST} )
-TARGET_LINK_LIBRARIES( remotetest exiv2lib ${LIBINTL_LIBRARIES} )
+TARGET_LINK_LIBRARIES( remotetest exiv2lib )
+ENDIF()
 
 # ******************************************************************************
 # Headers
diff --git a/xmpsdk/src/MD5.cpp b/src/MD5.cpp
similarity index 92%
rename from xmpsdk/src/MD5.cpp
rename to src/MD5.cpp
index f162b728..5d4034bb 100644
--- a/xmpsdk/src/MD5.cpp
+++ b/src/MD5.cpp
@@ -20,6 +20,9 @@
  * Still in the public domain.
  */
 
+#ifdef EXV_USING_CPP_ELEVEN
+#include <cstdint>
+#endif
 #include <cstring>
 
 #include "MD5.h"
@@ -46,7 +49,7 @@ byteSwap(UWORD32 *buf, unsigned words)
  * initialization constants.
  */
 void
-MD5Init(struct MD5_CTX *ctx)
+EXIV2_MD5Init(struct MD5_CTX *ctx)
 {
 	ctx->buf[0] = 0x67452301;
 	ctx->buf[1] = 0xefcdab89;
@@ -62,7 +65,7 @@ MD5Init(struct MD5_CTX *ctx)
  * of bytes.
  */
 void
-MD5Update(struct MD5_CTX *ctx, md5byte const *buf, unsigned len)
+EXIV2_MD5Update(struct MD5_CTX *ctx, md5byte const *buf, unsigned len)
 {
 	UWORD32 t;
 
@@ -80,7 +83,7 @@ MD5Update(struct MD5_CTX *ctx, md5byte const *buf, unsigned len)
 	/* First chunk is an odd size */
 	memcpy((md5byte *)ctx->in + 64 - t, buf, t);
 	byteSwap(ctx->in, 16);
-	MD5Transform(ctx->buf, ctx->in);
+	EXIV2_MD5Transform(ctx->buf, ctx->in);
 	buf += t;
 	len -= t;
 
@@ -88,7 +91,7 @@ MD5Update(struct MD5_CTX *ctx, md5byte const *buf, unsigned len)
 	while (len >= 64) {
 		memcpy(ctx->in, buf, 64);
 		byteSwap(ctx->in, 16);
-		MD5Transform(ctx->buf, ctx->in);
+		EXIV2_MD5Transform(ctx->buf, ctx->in);
 		buf += 64;
 		len -= 64;
 	}
@@ -98,11 +101,11 @@ MD5Update(struct MD5_CTX *ctx, md5byte const *buf, unsigned len)
 }
 
 /*
- * Final wrapup - pad to 64-byte boundary with the bit pattern 
+ * Final wrapup - pad to 64-byte boundary with the bit pattern
  * 1 0* (64-bit count of bits processed, MSB-first)
  */
 void
-MD5Final(md5byte digest[16], struct MD5_CTX *ctx)
+EXIV2_MD5Final(md5byte digest[16], struct MD5_CTX *ctx)
 {
 	int count = ctx->bytes[0] & 0x3f;	/* Number of bytes in ctx->in */
 	md5byte *p = (md5byte *)ctx->in + count;
@@ -116,7 +119,7 @@ MD5Final(md5byte digest[16], struct MD5_CTX *ctx)
 	if (count < 0) {	/* Padding forces an extra block */
 		memset(p, 0, count + 8);
 		byteSwap(ctx->in, 16);
-		MD5Transform(ctx->buf, ctx->in);
+		EXIV2_MD5Transform(ctx->buf, ctx->in);
 		p = (md5byte *)ctx->in;
 		count = 56;
 	}
@@ -126,7 +129,7 @@ MD5Final(md5byte digest[16], struct MD5_CTX *ctx)
 	/* Append length in bits and transform */
 	ctx->in[14] = ctx->bytes[0] << 3;
 	ctx->in[15] = ctx->bytes[1] << 3 | ctx->bytes[0] >> 29;
-	MD5Transform(ctx->buf, ctx->in);
+	EXIV2_MD5Transform(ctx->buf, ctx->in);
 
 	byteSwap(ctx->buf, 4);
 	memcpy(digest, ctx->buf, 16);
@@ -151,9 +154,13 @@ MD5Final(md5byte digest[16], struct MD5_CTX *ctx)
  * the data and converts bytes into longwords for this routine.
  */
 void
-MD5Transform(UWORD32 buf[4], UWORD32 const in[16])
+EXIV2_MD5Transform(UWORD32 buf[4], UWORD32 const in[16])
 {
+#ifdef EXV_USING_CPP_ELEVEN
+	UWORD32 a, b, c, d;
+#else
 	register UWORD32 a, b, c, d;
+#endif
 
 	a = buf[0];
 	b = buf[1];
diff --git a/xmpsdk/include/MD5.h b/src/MD5.h
similarity index 83%
rename from xmpsdk/include/MD5.h
rename to src/MD5.h
index f6c5e783..772fc157 100644
--- a/xmpsdk/include/MD5.h
+++ b/src/MD5.h
@@ -52,9 +52,9 @@ struct MD5_CTX {
 	UWORD32 in[16];
 };
 
-extern void MD5Init(struct MD5_CTX *context);
-extern void MD5Update(struct MD5_CTX *context, md5byte const *buf, unsigned len);
-extern void MD5Final(unsigned char digest[16], struct MD5_CTX *context);
-extern void MD5Transform(UWORD32 buf[4], UWORD32 const in[16]);
+extern void EXIV2_MD5Init(struct MD5_CTX *context);
+extern void EXIV2_MD5Update(struct MD5_CTX *context, md5byte const *buf, unsigned len);
+extern void EXIV2_MD5Final(unsigned char digest[16], struct MD5_CTX *context);
+extern void EXIV2_MD5Transform(UWORD32 buf[4], UWORD32 const in[16]);
 
 #endif
diff --git a/src/Makefile b/src/Makefile
index 1b955140..d1840346 100644
--- a/src/Makefile
+++ b/src/Makefile
@@ -88,6 +88,7 @@ CCSRC =  basicio.cpp           \
 	 jp2image.cpp          \
 	 jpgimage.cpp          \
 	 makernote.cpp         \
+	 MD5.cpp               \
 	 metadatum.cpp         \
 	 minoltamn.cpp         \
 	 mrwimage.cpp          \
@@ -121,7 +122,7 @@ CCSRC += sigmamn.cpp       \
 	 value.cpp             \
 	 version.cpp           \
 	 webpimage.cpp         \
-	 xmp.cpp               \
+	 xmp_exiv2.cpp         \
 	 xmpsidecar.cpp
 ifdef ENABLE_VIDEO
 CCSRC += asfvideo.cpp      \
@@ -159,8 +160,8 @@ SHELL = /bin/bash
 .PRECIOUS: %.cpp
 
 CPPFLAGS += $(SSH_CPPFLAGS) $(CURL_CPPFLAGS) $(XMPSDK_CPPFLAGS)
-LDFLAGS  += $(SSH_LDFLAGS) $(CURL_LDFLAGS) $(EXPAT_LDFLAGS) $(XMPSDK_LDFLAGS)
-LIBS     += $(SSH_LIBS) $(CURL_LIBS) $(EXPAT_LIBS) $(XMPSDK_LIBS)
+LDFLAGS  += $(SSH_LDFLAGS) $(CURL_LDFLAGS) $(XMPSDK_LDFLAGS)
+LIBS     += $(SSH_LIBS) $(CURL_LIBS) $(XMPSDK_LIBRARIES)
 
 # Generic variables
 CCHDR := $(CCHDR) $(CCSRC:.cpp=.hpp)
@@ -247,7 +248,7 @@ $(BINARY): %: %.o lib
 
 $(EXIV2EXE): lib $(EXIV2OBJ) $(EXIV2COBJ)
 	mkdir -pv ../bin 2>&1 > /dev/null
-	@$(LIBTOOL) --mode=link $(LINK.cc) -o ../bin/$@ $(LIBRARY) $(EXIV2OBJ) $(EXIV2COBJ) -rpath $(libdir)
+	@$(LIBTOOL) --mode=link $(LINK.cc)  $(EXIV2OBJ) $(EXIV2COBJ) -o ../bin/$@ -rdynamic $(LIBRARY) -rpath $(libdir) -Wl,-rpath,$(top_srcdir)/xmpsdk $(XMPSDK_STATIC_LIBS)
 
 install-header:
 	$(INSTALL_DIRS) $(DESTDIR)$(incdir)
diff --git a/src/actions.cpp b/src/actions.cpp
index 17444c5b..c8653131 100644
--- a/src/actions.cpp
+++ b/src/actions.cpp
@@ -42,7 +42,7 @@ EXIV2_RCSID("@(#) $Id: actions.cpp 4719 2017-03-08 20:42:28Z robinwmills $")
 #include "exif.hpp"
 #include "easyaccess.hpp"
 #include "iptc.hpp"
-#include "xmp.hpp"
+#include "xmp_exiv2.hpp"
 #include "preview.hpp"
 #include "futils.hpp"
 #include "i18n.h"                // NLS support.
@@ -228,7 +228,11 @@ namespace Action {
             Task* t = i->second;
             return t->clone();
         }
+#ifdef EXV_USING_CPP_ELEVEN
+        return Task::AutoPtr(nullptr);
+#else
         return Task::AutoPtr(0);
+#endif
     } // TaskFactory::create
 
     Print::~Print()
@@ -284,7 +288,11 @@ namespace Action {
                       << _("Failed to open the file\n");
             return -1;
         }
+#ifdef EXV_USING_CPP_ELEVEN
+        Exiv2::Image::AutoPtr image = Exiv2::ImageFactory::open(std::move(path_));
+#else
         Exiv2::Image::AutoPtr image = Exiv2::ImageFactory::open(path_);
+#endif
         assert(image.get() != 0);
         image->readMetadata();
         Exiv2::ExifData& exifData = image->exifData();
@@ -2113,7 +2121,11 @@ namespace {
         if ( bStdin )  Params::instance().getStdin(stdIn);
         Exiv2::BasicIo::AutoPtr ioStdin = Exiv2::BasicIo::AutoPtr(new Exiv2::MemIo(stdIn.pData_,stdIn.size_));
 
+#ifdef EXV_USING_CPP_ELEVEN
+        Exiv2::Image::AutoPtr sourceImage = bStdin ? Exiv2::ImageFactory::open(std::move(ioStdin)) : Exiv2::ImageFactory::open(std::move(source));
+#else
         Exiv2::Image::AutoPtr sourceImage = bStdin ? Exiv2::ImageFactory::open(ioStdin) : Exiv2::ImageFactory::open(source);
+#endif
         assert(sourceImage.get() != 0);
         sourceImage->readMetadata();
 
diff --git a/src/actions.hpp b/src/actions.hpp
index 9cce024c..94d7361a 100644
--- a/src/actions.hpp
+++ b/src/actions.hpp
@@ -75,7 +75,11 @@ namespace Action {
     class Task {
     public:
         //! Shortcut for an auto pointer.
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Task> AutoPtr;
+#else
         typedef std::auto_ptr<Task> AutoPtr;
+#endif
         //! Virtual destructor.
         virtual ~Task();
         //! Virtual copy construction.
@@ -159,7 +163,11 @@ namespace Action {
     public:
         virtual ~Print();
         virtual int run(const std::string& path);
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Print> AutoPtr;
+#else
         typedef std::auto_ptr<Print> AutoPtr;
+#endif
         AutoPtr clone() const;
 
         //! Print the Jpeg comment
@@ -216,7 +224,11 @@ namespace Action {
     public:
         virtual ~Rename();
         virtual int run(const std::string& path);
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Rename> AutoPtr;
+#else
         typedef std::auto_ptr<Rename> AutoPtr;
+#endif
         AutoPtr clone() const;
 
     private:
@@ -228,7 +240,11 @@ namespace Action {
     public:
         virtual ~Adjust();
         virtual int run(const std::string& path);
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Adjust> AutoPtr;
+#else
         typedef std::auto_ptr<Adjust> AutoPtr;
+#endif
         AutoPtr clone() const;
 
     private:
@@ -251,7 +267,11 @@ namespace Action {
     public:
         virtual ~Erase();
         virtual int run(const std::string& path);
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Erase> AutoPtr;
+#else
         typedef std::auto_ptr<Erase> AutoPtr;
+#endif
         AutoPtr clone() const;
 
         /*!
@@ -297,7 +317,11 @@ namespace Action {
     public:
         virtual ~Extract();
         virtual int run(const std::string& path);
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Extract> AutoPtr;
+#else
         typedef std::auto_ptr<Extract> AutoPtr;
+#endif
         AutoPtr clone() const;
 
         /*!
@@ -336,7 +360,11 @@ namespace Action {
     public:
         virtual ~Insert();
         virtual int run(const std::string& path);
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Insert> AutoPtr;
+#else
         typedef std::auto_ptr<Insert> AutoPtr;
+#endif
         AutoPtr clone() const;
 
         /*!
@@ -377,7 +405,11 @@ namespace Action {
     public:
         virtual ~Modify();
         virtual int run(const std::string& path);
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<Modify> AutoPtr;
+#else
         typedef std::auto_ptr<Modify> AutoPtr;
+#endif
         AutoPtr clone() const;
         Modify() {}
         //! Apply modification commands to the \em pImage, return 0 if successful.
@@ -410,7 +442,11 @@ namespace Action {
     public:
         virtual ~FixIso();
         virtual int run(const std::string& path);
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<FixIso> AutoPtr;
+#else
         typedef std::auto_ptr<FixIso> AutoPtr;
+#endif
         AutoPtr clone() const;
 
     private:
@@ -428,7 +464,11 @@ namespace Action {
     public:
         virtual ~FixCom();
         virtual int run(const std::string& path);
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<FixCom> AutoPtr;
+#else
         typedef std::auto_ptr<FixCom> AutoPtr;
+#endif
         AutoPtr clone() const;
 
     private:
diff --git a/src/asfvideo.cpp b/src/asfvideo.cpp
index eace7073..2dc38e6e 100644
--- a/src/asfvideo.cpp
+++ b/src/asfvideo.cpp
@@ -296,10 +296,17 @@ namespace Exiv2 {
 
     using namespace Exiv2::Internal;
 
+#ifdef EXV_USING_CPP_ELEVEN
+    AsfVideo::AsfVideo(BasicIo::AutoPtr io)
+        : Image(ImageType::asf, mdNone, std::move(io))
+    {
+    } // AsfVideo::AsfVideo
+#else
     AsfVideo::AsfVideo(BasicIo::AutoPtr io)
         : Image(ImageType::asf, mdNone, io)
     {
     } // AsfVideo::AsfVideo
+#endif
 
     std::string AsfVideo::mimeType() const
     {
@@ -792,7 +799,11 @@ namespace Exiv2 {
 
     Image::AutoPtr newAsfInstance(BasicIo::AutoPtr io, bool /*create*/)
     {
+#ifdef EXV_USING_CPP_ELEVEN
+        Image::AutoPtr image(new AsfVideo(std::move(io)));
+#else
         Image::AutoPtr image(new AsfVideo(io));
+#endif
         if (!image->good()) {
             image.reset();
         }
diff --git a/src/bmpimage.cpp b/src/bmpimage.cpp
index 4cbb1acc..5bfeb4f5 100644
--- a/src/bmpimage.cpp
+++ b/src/bmpimage.cpp
@@ -46,10 +46,17 @@ EXIV2_RCSID("@(#) $Id$")
 // class member definitions
 namespace Exiv2 {
 
+#ifdef EXV_USING_CPP_ELEVEN
+    BmpImage::BmpImage(BasicIo::AutoPtr io)
+        : Image(ImageType::bmp, mdNone, std::move(io))
+    {
+    } // BmpImage::BmpImage
+#else
     BmpImage::BmpImage(BasicIo::AutoPtr io)
         : Image(ImageType::bmp, mdNone, io)
     {
     } // BmpImage::BmpImage
+#endif
 
     std::string BmpImage::mimeType() const
     {
@@ -131,7 +138,11 @@ namespace Exiv2 {
     // free functions
     Image::AutoPtr newBmpInstance(BasicIo::AutoPtr io, bool /*create*/)
     {
+#ifdef EXV_USING_CPP_ELEVEN
+        Image::AutoPtr image(new BmpImage(std::move(io)));
+#else
         Image::AutoPtr image(new BmpImage(io));
+#endif
         if (!image->good())
         {
             image.reset();
diff --git a/src/convert.cpp b/src/convert.cpp
index 26a5fd8b..c6131845 100644
--- a/src/convert.cpp
+++ b/src/convert.cpp
@@ -35,7 +35,7 @@ EXIV2_RCSID("@(#) $Id$")
 #include "types.hpp"
 #include "exif.hpp"
 #include "iptc.hpp"
-#include "xmp.hpp"
+#include "xmp_exiv2.hpp"
 #include "futils.hpp"
 #include "convert.hpp"
 
@@ -63,7 +63,7 @@ EXIV2_RCSID("@(#) $Id$")
 // Adobe XMP Toolkit
 #ifdef EXV_HAVE_XMP_TOOLKIT
 # define TXMP_STRING_TYPE std::string
-# include <XMPSDK.hpp>
+# include <XMP.hpp>
 # include <MD5.h>
 #endif // EXV_HAVE_XMP_TOOLKIT
 
@@ -1182,7 +1182,7 @@ namespace Exiv2 {
         MD5_CTX    context;
         unsigned char digest[16];
 
-        MD5Init ( &context );
+        EXIV2_MD5Init ( &context );
         for (unsigned int i = 0; i < EXV_COUNTOF(conversion_); ++i) {
             const Conversion& c = conversion_[i];
             if (c.metadataId_ == mdExif) {
@@ -1196,10 +1196,10 @@ namespace Exiv2 {
                 if (pos == exifData_->end()) continue;
                 DataBuf data(pos->size());
                 pos->copy(data.pData_, littleEndian /* FIXME ? */);
-                MD5Update ( &context, data.pData_, data.size_);
+                EXIV2_MD5Update ( &context, data.pData_, data.size_);
             }
         }
-        MD5Final(digest, &context);
+        EXIV2_MD5Final(digest, &context);
         res << ';';
         res << std::setw(2) << std::setfill('0') << std::hex << std::uppercase;
         for (int i = 0; i < 16; ++i) {
@@ -1268,11 +1268,11 @@ namespace Exiv2 {
         MD5_CTX context;
         unsigned char digest[16];
 
-        MD5Init(&context);
+        EXIV2_MD5Init(&context);
 
         DataBuf data = IptcParser::encode(*iptcData_);
-        MD5Update(&context, data.pData_, data.size_);
-        MD5Final(digest, &context);
+        EXIV2_MD5Update(&context, data.pData_, data.size_);
+        EXIV2_MD5Final(digest, &context);
         res << std::setw(2) << std::setfill('0') << std::hex << std::uppercase;
         for (int i = 0; i < 16; ++i) {
             res << static_cast<int>(digest[i]);
diff --git a/src/cr2image.cpp b/src/cr2image.cpp
index 2907426c..f02a55f1 100644
--- a/src/cr2image.cpp
+++ b/src/cr2image.cpp
@@ -51,8 +51,13 @@ namespace Exiv2 {
 
     using namespace Internal;
 
+#ifdef EXV_USING_CPP_ELEVEN
+    Cr2Image::Cr2Image(BasicIo::AutoPtr io, bool /*create*/)
+        : Image(ImageType::cr2, mdExif | mdIptc | mdXmp, std::move(io))
+#else
     Cr2Image::Cr2Image(BasicIo::AutoPtr io, bool /*create*/)
         : Image(ImageType::cr2, mdExif | mdIptc | mdXmp, io)
+#endif
     {
     } // Cr2Image::Cr2Image
 
@@ -190,7 +195,11 @@ namespace Exiv2 {
                      ed.end());
         }
 
+#ifdef EXV_USING_CPP_ELEVEN
+        std::unique_ptr<TiffHeaderBase> header(new Cr2Header(byteOrder));
+#else
         std::auto_ptr<TiffHeaderBase> header(new Cr2Header(byteOrder));
+#endif
         OffsetWriter offsetWriter;
         offsetWriter.setOrigin(OffsetWriter::cr2RawIfdOffset, Cr2Header::offset2addr(), byteOrder);
         return TiffParserWorker::encode(io,
@@ -209,7 +218,11 @@ namespace Exiv2 {
     // free functions
     Image::AutoPtr newCr2Instance(BasicIo::AutoPtr io, bool create)
     {
+#ifdef EXV_USING_CPP_ELEVEN
+        Image::AutoPtr image(new Cr2Image(std::move(io), create));
+#else
         Image::AutoPtr image(new Cr2Image(io, create));
+#endif
         if (!image->good()) {
             image.reset();
         }
diff --git a/src/crwimage.cpp b/src/crwimage.cpp
index ca79aa74..6c369587 100644
--- a/src/crwimage.cpp
+++ b/src/crwimage.cpp
@@ -82,8 +82,13 @@ namespace Exiv2 {
 
     using namespace Internal;
 
+#ifdef EXV_USING_CPP_ELEVEN
+    CrwImage::CrwImage(BasicIo::AutoPtr io, bool /*create*/)
+        : Image(ImageType::crw, mdExif | mdComment, std::move(io))
+#else
     CrwImage::CrwImage(BasicIo::AutoPtr io, bool /*create*/)
         : Image(ImageType::crw, mdExif | mdComment, io)
+#endif
     {
     } // CrwImage::CrwImage
 
@@ -222,7 +227,11 @@ namespace Exiv2 {
     // free functions
     Image::AutoPtr newCrwInstance(BasicIo::AutoPtr io, bool create)
     {
+#ifdef EXV_USING_CPP_ELEVEN
+        Image::AutoPtr image(new CrwImage(std::move(io), create));
+#else
         Image::AutoPtr image(new CrwImage(io, create));
+#endif
         if (!image->good()) {
             image.reset();
         }
@@ -360,7 +369,11 @@ namespace Exiv2 {
 
     void CiffComponent::add(AutoPtr component)
     {
+#ifdef EXV_USING_CPP_ELEVEN
+        doAdd(std::move(component));
+#else
         doAdd(component);
+#endif
     }
 
     void CiffEntry::doAdd(AutoPtr /*component*/)
@@ -476,7 +489,11 @@ namespace Exiv2 {
             }
             m->setDir(this->tag());
             m->read(pData, size, o, byteOrder);
+#ifdef EXV_USING_CPP_ELEVEN
+            add(std::move(m));
+#else
             add(m);
+#endif
             o += 10;
         }
     }  // CiffDirectory::readDirectory
@@ -848,7 +865,11 @@ namespace Exiv2 {
                 // Directory doesn't exist yet, add it
                 m_ = AutoPtr(new CiffDirectory(csd.crwDir_, csd.parent_));
                 cc_ = m_.get();
+#ifdef EXV_USING_CPP_ELEVEN
+                add(std::move(m_));
+#else
                 add(m_);
+#endif
             }
             // Recursive call to next lower level directory
             cc_ = cc_->add(crwDirs, crwTagId);
@@ -865,7 +886,11 @@ namespace Exiv2 {
                 // Tag doesn't exist yet, add it
                 m_ = AutoPtr(new CiffEntry(crwTagId, tag()));
                 cc_ = m_.get();
+#ifdef EXV_USING_CPP_ELEVEN
+                add(std::move(m_));
+#else
                 add(m_);
+#endif
             }
         }
         return cc_;
diff --git a/src/crwimage_int.hpp b/src/crwimage_int.hpp
index 01a0c572..f14ab348 100644
--- a/src/crwimage_int.hpp
+++ b/src/crwimage_int.hpp
@@ -96,7 +96,11 @@ namespace Exiv2 {
     class CiffComponent {
     public:
         //! CiffComponent auto_ptr type
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<CiffComponent> AutoPtr;
+#else
         typedef std::auto_ptr<CiffComponent> AutoPtr;
+#endif
         //! Container type to hold all metadata
         typedef std::vector<CiffComponent*> Components;
 
@@ -440,7 +444,11 @@ namespace Exiv2 {
     class CiffHeader {
     public:
         //! CiffHeader auto_ptr type
+#ifdef EXV_USING_CPP_ELEVEN
+        typedef std::unique_ptr<CiffHeader> AutoPtr;
+#else
         typedef std::auto_ptr<CiffHeader> AutoPtr;
+#endif
 
         //! @name Creators
         //@{
diff --git a/src/epsimage.cpp b/src/epsimage.cpp
index c50b6382..702f5f2e 100644
--- a/src/epsimage.cpp
+++ b/src/epsimage.cpp
@@ -1079,8 +1079,13 @@ namespace {
 namespace Exiv2
 {
 
+#ifdef EXV_USING_CPP_ELEVEN
+    EpsImage::EpsImage(BasicIo::AutoPtr io, bool create)
+            : Image(ImageType::eps, mdXmp, std::move(io))
+#else
     EpsImage::EpsImage(BasicIo::AutoPtr io, bool create)
             : Image(ImageType::eps, mdXmp, io)
+#endif
     {
         //LogMsg::setLevel(LogMsg::debug);
         if (create) {
@@ -1157,7 +1162,11 @@ namespace Exiv2
     // free functions
     Image::AutoPtr newEpsInstance(BasicIo::AutoPtr io, bool create)
     {
+#ifdef EXV_USING_CPP_ELEVEN
+        Image::AutoPtr image(new EpsImage(std::move(io), create));
+#else
         Image::AutoPtr image(new EpsImage(io, create));
+#endif
         if (!image->good()) {
             image.reset();
         }
